% function E=energy(x1,x2,x3,W12,W23,b1,b2,b3,v1,v2,v3,NL);
% 
% compute the energy of a three layer rectified Gaussian 
% belief network

function E=energy(x1,x2,x3,W12,W23,b1,b2,b3,v1,v2,v3,NL);

x2r=rect(x2,1);
x1r=rect(x1,NL);

E=(x1-b1)'*(x1-b1)/v1+(x2-W12*x1r-b2)'*(x2-W12*x1r-b2)/v2+...
    (x3-W23*x2r-b3)'*(x3-W23*x2r-b3)/v3;

E=0.5*E;

