% function x1n=topsample(x1,x2,W12,b1,b2,v1,v2,NL);
% sample from top layer given middle layer

function x1n=topsample(x1,x2,W12,b1,b2,v1,v2,NL);

tiny=exp(-700);

n1=length(x1);

x1r=rect(x1,NL); % rectified top activities

for j=1:n1,

  % top down mean and var 

  mua=b1(j); % mean is bias
  va=v1;     % variance

  % combine top down with bottom up 
  
  y=x2-W12*x1r-b2+W12(:,j)*x1r(j);
  
  vb=1/(1/va+W12(:,j)'*W12(:,j)/v2); % combined variance 
  mub=vb*(mua/va+y'*W12(:,j)/v2);    % combined mean

  if NL==1,
    samp=twogauss(mua,va,mub,vb);   % sample from this two-piece gaussian
  elseif NL==3,
    samp=threegauss(mua,va,mub,vb);
  end;
  
  % update x1 and x1r
  x1(j)=samp;
  x1r(j)=rect(x1(j),NL);
  
  % plot function
  
  plt=0;
  if plt==1,  
    pneg=1/sqrt(2*pi*vn)*exp(-(mun^2)/(2*vn));
    ppos=1/sqrt(2*pi*vp)*exp(-(mup^2)/(2*vp));
    alpha=(ppos+tiny)/(ppos+pneg+2*tiny); % weight of negative portion
    qq=-3:0.01:3;
    qqn=alpha/sqrt(2*pi*va)*exp(-((qq-mua).^2/(2*va)));
    qqp=(1-alpha)/sqrt(2*pi*vb)*exp(-((qq-mub).^2/(2*vb)));
    plot(qq,qqn.*(qq<0)+qqp.*(qq>=0),'r');  grid;  drawnow;
  end;

end;

x1n=x1;